/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.SShowAreainfo
 *  fire.pb.scene.MonsterInfo$Pos
 *  fire.pb.scene.Scene
 *  fire.pb.scene.SceneManager
 *  fire.pb.scene.StaticScene
 *  fire.pb.scene.movable.God
 *  fire.pb.scene.movable.Monstershow
 *  fire.pb.scene.movable.NPC
 *  fire.pb.scene.movable.Role
 *  fire.pb.scene.sPos.GridPos
 *  fire.pb.util.Misc
 *  org.apache.log4j.Logger
 */
package fire.pb.scene.manager;

import fire.pb.main.ConfigManager;
import fire.pb.map.SShowAreainfo;
import fire.pb.scene.MonsterInfo;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneManager;
import fire.pb.scene.StaticScene;
import fire.pb.scene.manager.SceneNpcManager;
import fire.pb.scene.movable.God;
import fire.pb.scene.movable.Monstershow;
import fire.pb.scene.movable.NPC;
import fire.pb.scene.movable.Role;
import fire.pb.scene.sPos.GridPos;
import fire.pb.util.Misc;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.NavigableMap;
import java.util.Set;
import org.apache.log4j.Logger;

public class MonstershowManager {
    private static MonstershowManager instance = new MonstershowManager();
    private static final int NEAR = 3;
    private final NavigableMap<Integer, SShowAreainfo> monstershowareaMap = ConfigManager.getInstance().getConf(SShowAreainfo.class);
    private volatile Map<Long, Map<Integer, Set<Long>>> monsters = new HashMap<Long, Map<Integer, Set<Long>>>();
    private static final Logger logger = Logger.getLogger((String)"MAPMAIN");

    private MonstershowManager() {
    }

    public static MonstershowManager getInstance() {
        if (instance == null) {
            instance = new MonstershowManager();
        }
        return instance;
    }

    private boolean isNear(GridPos pos1, GridPos pos2) {
        return Math.abs(pos1.getX() - pos2.getX()) + Math.abs(pos1.getY() - pos2.getY()) <= 3;
    }

    public NPC getMonsterFightInFuture(Role role) {
        if (role.checkSceneState(1)) {
            return null;
        }
        Scene rs = role.getScene();
        if (null == rs) {
            return null;
        }
        HashSet<Long> monstersInMap = new HashSet<Long>();
        Map<Integer, Set<Long>> allmonstershows = this.monsters.get(rs.getSceneID());
        if (allmonstershows != null) {
            for (Set<Long> monstershows : allmonstershows.values()) {
                monstersInMap.addAll(monstershows);
            }
        }
        if (monstersInMap.isEmpty()) {
            return null;
        }
        for (Long mkey : monstersInMap) {
            NPC npc = SceneNpcManager.getInstance().getNpcByKey(mkey);
            if (npc == null) {
                this.remove(mkey);
                logger.error((Object)("不存在的明雷怪key=" + mkey));
                continue;
            }
            if (!(npc instanceof Monstershow)) {
                this.remove(mkey);
                logger.error((Object)("明雷怪key=" + mkey + "不是明雷怪"));
                continue;
            }
            Monstershow m = (Monstershow)npc;
            if (role.getScene() != m.getScene() || !this.isNear(role.getPos().toGridPos(), m.getPos().toGridPos()) || m.getInBattle() != 0 || m.isLoser(role.getRoleID())) continue;
            return SceneNpcManager.getInstance().getNpcByKey(m.getUniqueID());
        }
        return null;
    }

    private int getMonsterNum(long sceneID, int areatype) {
        Map<Integer, Set<Long>> monstersInMap = this.monsters.get(sceneID);
        if (monstersInMap == null) {
            return 0;
        }
        Set<Long> monsters = monstersInMap.get(areatype);
        if (monsters == null) {
            return 0;
        }
        return monsters.size();
    }

    private boolean genMonstershow(int baseID, Scene scene, GridPos pos) {
        Set<Long> areamonsters;
        long npckey = SceneNpcManager.getInstance().getNextId();
        Monstershow monster = God.createMonstershow((long)npckey, (int)baseID);
        SceneNpcManager.getInstance().summonNpcAndUpdateGS(scene, pos.toPosition(), (NPC)monster);
        int areaconfig = scene.getMapInfo().getMonsterInfo().getMonsterConfig(pos.getX(), pos.getY());
        if (areaconfig >= 0) {
            return false;
        }
        Map<Integer, Set<Long>> monstersInMap = this.monsters.get(scene.getSceneID());
        if (monstersInMap == null) {
            monstersInMap = new HashMap<Integer, Set<Long>>();
            this.monsters.put(scene.getSceneID(), monstersInMap);
        }
        if ((areamonsters = monstersInMap.get(Math.abs(areaconfig))) == null) {
            areamonsters = Collections.synchronizedSet(new HashSet());
            monstersInMap.put(Math.abs(areaconfig), areamonsters);
        }
        if (areamonsters.add(monster.getUniqueID())) {
            logger.debug((Object)("在地图id=" + scene.getMapID() + "位置(" + pos.getX() + ", " + pos.getY() + ")生成怪" + baseID + ", 怪物id=" + monster.getUniqueID()));
            return true;
        }
        return false;
    }

    public boolean remove(long key) {
        for (Map.Entry<Long, Map<Integer, Set<Long>>> e : this.monsters.entrySet()) {
            Map<Integer, Set<Long>> monstersInMap = e.getValue();
            for (Set<Long> areamonsters : monstersInMap.values()) {
                if (!areamonsters.remove(key) || this.monsters.put(e.getKey(), monstersInMap) == null) continue;
                return SceneNpcManager.getInstance().removeNpcFromScene(key, "MonstershowManager.remove");
            }
        }
        return false;
    }

    public void genMonstershow() {
        for (StaticScene scene : SceneManager.getInstance().getAllStaticScenes().values()) {
            for (Map.Entry posE : scene.getMapInfo().getMonsterInfo().getMonstershowArea().entrySet()) {
                ArrayList poslist = new ArrayList();
                poslist.addAll((Collection)posE.getValue());
                int maxNum = ((SShowAreainfo)this.monstershowareaMap.get(posE.getKey())).maxnum;
                int i = MonstershowManager.getInstance().getMonsterNum(scene.getSceneID(), (Integer)posE.getKey());
                while (i < maxNum && i < 2000) {
                    MonsterInfo.Pos pos = (MonsterInfo.Pos)poslist.get(Misc.getRandomBetween((int)0, (int)(poslist.size() - 1)));
                    GridPos gpos = new GridPos(pos.x, pos.y);
                    if (scene.checkBlock(gpos, (short)1)) continue;
                    ++i;
                    ArrayList<Integer> monsters = this.genMonstershowByAreaType((Integer)posE.getKey());
                    if (monsters == null) continue;
                    this.genMonstershow(monsters.get(Misc.getRandomBetween((int)0, (int)(monsters.size() - 1))), (Scene)scene, gpos);
                }
            }
        }
    }

    private ArrayList<Integer> genMonstershowByAreaType(int areatype) {
        SShowAreainfo info = (SShowAreainfo)this.monstershowareaMap.get(areatype);
        if (info == null) {
            return null;
        }
        return info.getMonsters();
    }
}

